diff --git a/web/regression/javascript/selection/row_selector_spec.js b/web/regression/javascript/selection/row_selector_spec.js
index 10697e6a..5907c449 100644
--- a/web/regression/javascript/selection/row_selector_spec.js
+++ b/web/regression/javascript/selection/row_selector_spec.js
@@ -2,26 +2,33 @@ define(
   ["jquery",
     "underscore",
     "slickgrid/slick.grid",
+    "sources/selection/active_cell_capture",
     "sources/selection/row_selector",
-    "slickgrid/slick.rowselectionmodel",
+
     "slickgrid",
+    'slickgrid/slick.cellrangedecorator',
+    'slickgrid/slick.cellrangeselector',
+    "slickgrid/slick.cellselectionmodel",
   ],
-  function ($, _, SlickGrid, RowSelector, RowSelectionModel, Slick) {
+  function ($, _, SlickGrid, ActiveCellCapture, RowSelector, Slick) {
     describe("RowSelector", function () {
-      var container, data, columnDefinitions, grid, rowSelectionModel;
+      var container, data, columnDefinitions, grid, cellSelectionModel;
 
       beforeEach(function () {
         container = $("<div></div>");
         container.height(9999);
+        container.width(9999);
 
         columnDefinitions = [{
           id: '1',
           name: 'some-column-name',
-          selectable: true
+          selectable: true,
+          pos: 0
         }, {
           id: '2',
           name: 'second column',
-          selectable: true
+          selectable: true,
+          pos: 1
         }];
 
         var rowSelector = new RowSelector();
@@ -32,8 +39,10 @@ define(
         columnDefinitions = rowSelector.getColumnDefinitionsWithCheckboxes(columnDefinitions);
         grid = new SlickGrid(container, data, columnDefinitions);
 
-        rowSelectionModel = new RowSelectionModel();
-        grid.setSelectionModel(rowSelectionModel);
+        grid.registerPlugin(new ActiveCellCapture());
+        cellSelectionModel = new Slick.CellSelectionModel();
+        grid.setSelectionModel(cellSelectionModel);
+
         grid.registerPlugin(rowSelector);
         grid.invalidate();
 
@@ -53,9 +62,9 @@ define(
         expect(leftmostColumn.selectable).toBe(false);
       });
 
-      it("renders a checkbox the leftmost column", function () {
-        expect(container.find('.sr').length).toBe(11);
-        expect(container.find('.sr .sc:first-child input[type="checkbox"]').length).toBe(10);
+      it("renders a span on the leftmost column", function () {
+        expect(container.find('.slick-row').length).toBe(10);
+        expect(container.find('.slick-row .slick-cell:first-child input[type="checkbox"]').length).toBe(10);
       });
 
       it("preserves the other attributes of column definitions", function () {
@@ -64,44 +73,44 @@ define(
       });
 
       describe("selecting rows", function () {
-        describe("when the user clicks a row header checkbox", function () {
+        describe("when the user clicks a row header span", function () {
           it("selects the row", function () {
-            container.find('.sr .sc:first-child input[type="checkbox"]')[0].click();
+            container.find('.slick-row .slick-cell:first-child input[type="checkbox"]')[0].click();
 
-            var selectedRanges = rowSelectionModel.getSelectedRanges();
+            var selectedRanges = cellSelectionModel.getSelectedRanges();
             expectOnlyTheFirstRowToBeSelected(selectedRanges);
           });
 
           it("checks the checkbox", function () {
-            container.find('.sr .sc:first-child input[type="checkbox"]')[5].click();
+            container.find('.slick-row .slick-cell:first-child input[type="checkbox"]')[5].click();
 
-            expect($(container.find('.sr .sc:first-child input[type="checkbox"]')[5])
+            expect($(container.find('.slick-row .slick-cell:first-child input[type="checkbox"]')[5])
               .is(':checked')).toBeTruthy();
           });
         });
 
         describe("when the user clicks a row header", function () {
           it("selects the row", function () {
-            container.find('.sr .sc:first-child')[0].click();
+            container.find('.slick-row .slick-cell:first-child')[0].click();
 
-            var selectedRanges = rowSelectionModel.getSelectedRanges();
+            var selectedRanges = cellSelectionModel.getSelectedRanges();
             expectOnlyTheFirstRowToBeSelected(selectedRanges);
           });
 
           it("checks the checkbox", function () {
-            container.find('.sr .sc:first-child')[7].click();
+            container.find('.slick-row .slick-cell:first-child')[7].click();
 
-            expect($(container.find('.sr .sc:first-child input[type="checkbox"]')[7])
+            expect($(container.find('.slick-row .slick-cell:first-child input[type="checkbox"]')[7])
               .is(':checked')).toBeTruthy();
           });
         });
 
         describe("when the user clicks multiple row headers", function () {
           it("selects another row", function () {
-            container.find('.sr .sc:first-child')[4].click();
-            container.find('.sr .sc:first-child')[0].click();
+            container.find('.slick-row .slick-cell:first-child')[4].click();
+            container.find('.slick-row .slick-cell:first-child')[0].click();
 
-            var selectedRanges = rowSelectionModel.getSelectedRanges();
+            var selectedRanges = cellSelectionModel.getSelectedRanges();
             expect(selectedRanges.length).toEqual(2);
 
             var row1 = selectedRanges[0];
@@ -117,12 +126,12 @@ define(
         describe("when a column was already selected", function () {
           beforeEach(function () {
             var selectedRanges = [new Slick.Range(0, 0, 0, 1)];
-            rowSelectionModel.setSelectedRanges(selectedRanges);
+            cellSelectionModel.setSelectedRanges(selectedRanges);
           });
 
           it("deselects the column", function () {
-            container.find('.sr .sc:first-child')[0].click();
-            var selectedRanges = rowSelectionModel.getSelectedRanges();
+            container.find('.slick-row .slick-cell:first-child')[0].click();
+            var selectedRanges = cellSelectionModel.getSelectedRanges();
 
             expectOnlyTheFirstRowToBeSelected(selectedRanges);
           })
@@ -130,31 +139,31 @@ define(
 
         describe("when the row is deselected through setSelectedRanges", function () {
           beforeEach(function () {
-            container.find('.sr .sc:first-child')[4].click();
+            container.find('.slick-row .slick-cell:first-child')[4].click();
           });
 
           it("should uncheck the checkbox", function () {
-            rowSelectionModel.setSelectedRanges([]);
+            cellSelectionModel.setSelectedRanges([]);
 
-            expect($(container.find('.sr .sc:first-child input[type="checkbox"]')[4])
+            expect($(container.find('.slick-row .slick-cell:first-child input[type="checkbox"]')[4])
               .is(':checked')).toBeFalsy();
           });
         });
 
         describe("click a second time", function () {
           beforeEach(function () {
-            container.find('.sr .sc:first-child')[1].click();
+            container.find('.slick-row .slick-cell:first-child')[1].click();
           });
 
           it("unchecks checkbox", function () {
-            container.find('.sr .sc:first-child')[1].click();
-            expect($(container.find('.sr .sc:first-child input[type="checkbox"]')[1])
+            container.find('.slick-row .slick-cell:first-child')[1].click();
+            expect($(container.find('.slick-row .slick-cell:first-child input[type="checkbox"]')[1])
               .is(':checked')).toBeFalsy();
           });
 
           it("unselects the row", function () {
-            container.find('.sr .sc:first-child')[1].click();
-            var selectedRanges = rowSelectionModel.getSelectedRanges();
+            container.find('.slick-row .slick-cell:first-child')[1].click();
+            var selectedRanges = cellSelectionModel.getSelectedRanges();
 
             expect(selectedRanges.length).toEqual(0);
           })
diff --git a/web/regression/javascript/slickgrid/cell_selector_spec.js b/web/regression/javascript/slickgrid/cell_selector_spec.js
new file mode 100644
index 00000000..f1178541
--- /dev/null
+++ b/web/regression/javascript/slickgrid/cell_selector_spec.js
@@ -0,0 +1,77 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2017, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+define(["jquery",
+    "slickgrid/slick.grid",
+    "slickgrid/slick.rowselectionmodel",
+    "sources/slickgrid/cell_selector",
+    "sources/selection/range_selection_helper"
+  ],
+  function ($, SlickGrid, RowSelectionModel, CellSelector, RangeSelectionHelper) {
+    describe("CellSelector", function () {
+      var container, columns, cellSelector, data, rowSelectionModel, grid;
+      beforeEach(function () {
+        container = $("<div></div>");
+        container.height(9999);
+        container.width(9999);
+        columns = [{
+          name: 'some-column-name',
+        }, {
+          name: 'second column',
+        }];
+
+        cellSelector = new CellSelector();
+
+        data = [];
+        for (var i = 0; i < 10; i++) {
+          data.push({'some-column-name': 'some-value-' + i, 'second column': 'second value ' + i});
+        }
+        grid = new SlickGrid(container, data, columns);
+
+        rowSelectionModel = new RowSelectionModel();
+        grid.setSelectionModel(rowSelectionModel);
+
+        grid.registerPlugin(cellSelector);
+        grid.invalidate();
+
+        $("body").append(container);
+      });
+
+      afterEach(function () {
+        $("body").find(container).remove();
+      });
+
+      describe("when the user clicks or tabs to a cell", function () {
+        it("sets the selected range to that cell", function () {
+          var row = 1, column = 0;
+          $(container.find(".slick-row .slick-cell.l" + column)[row]).click();
+
+          var selectedRanges = rowSelectionModel.getSelectedRanges();
+          expect(selectedRanges.length).toBe(1);
+          expect(selectedRanges[0].fromCell).toBe(0);
+          expect(selectedRanges[0].toCell).toBe(0);
+          expect(selectedRanges[0].fromRow).toBe(1);
+          expect(selectedRanges[0].toRow).toBe(1);
+        });
+
+        it("deselects previously selected ranges", function () {
+          var row2Range = RangeSelectionHelper.rangeForRow(grid, 2);
+          var ranges = RangeSelectionHelper.addRange(rowSelectionModel.getSelectedRanges(),
+            row2Range);
+          rowSelectionModel.setSelectedRanges(ranges);
+
+          var row = 4, column = 1;
+          $(container.find(".slick-row .slick-cell.l" + column)[row]).click();
+
+          expect(RangeSelectionHelper.isRangeSelected(rowSelectionModel.getSelectedRanges(), row2Range))
+            .toBe(false);
+        });
+      });
+    });
+  });
\ No newline at end of file
diff --git a/web/regression/javascript/slickgrid/event_handlers/handle_query_output_keyboard_event_spec.js b/web/regression/javascript/slickgrid/event_handlers/handle_query_output_keyboard_event_spec.js
new file mode 100644
index 00000000..b61e5aff
--- /dev/null
+++ b/web/regression/javascript/slickgrid/event_handlers/handle_query_output_keyboard_event_spec.js
@@ -0,0 +1,145 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2017, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+define([
+    'sources/slickgrid/event_handlers/handle_query_output_keyboard_event',
+    'sources/selection/clipboard',
+    'sources/selection/range_selection_helper',
+    'slickgrid',
+    'slickgrid/slick.cellrangedecorator',
+    'slickgrid/slick.cellrangeselector',
+    'slickgrid/slick.cellselectionmodel',
+  ],
+function (handleQueryOutputKeyboardEvent, clipboard, RangeSelectionHelper) {
+  var Slick = window.Slick;
+
+  describe('#handleQueryOutputKeyboardEvent', function () {
+    var event, view, grid, slickEvent;
+    beforeEach(function () {
+      event = {
+        shiftKey: false,
+        ctrlKey: false,
+        metaKey: false,
+        which: -1,
+        keyCode: -1,
+        preventDefault: jasmine.createSpy('preventDefault')
+      };
+
+      var data = [['', '0,0-cell-content', '0,1-cell-content'],
+        ['', '1,0-cell-content', '1,1-cell-content'],
+        ['', '2,0-cell-content', '2,1-cell-content']];
+      var columnDefinitions = [{name: 'checkboxColumn'}, {pos: 1, name: 'firstColumn'}, {
+        pos: 2,
+        name: 'secondColumn'
+      }];
+      grid = new Slick.Grid($('<div></div>'), data, columnDefinitions);
+      grid.setSelectionModel(new Slick.CellSelectionModel());
+
+      slickEvent = {
+        grid: grid
+      };
+
+      view = {};
+      spyOn(clipboard, 'copyTextToClipboard');
+    });
+
+    describe("when a range is selected", function () {
+      beforeEach(function () {
+        grid.getSelectionModel().setSelectedRanges([
+          RangeSelectionHelper.rangeForRow(grid, 0),
+          RangeSelectionHelper.rangeForRow(grid, 2),
+        ]);
+      });
+
+      describe("pressing Command + C", function () {
+        beforeEach(function () {
+          event.metaKey = true;
+          event.keyCode = 67;
+        });
+
+        it("copies the cell content to the clipboard", function () {
+          handleQueryOutputKeyboardEvent(event, slickEvent);
+
+          expect(clipboard.copyTextToClipboard).toHaveBeenCalledWith("'0,0-cell-content','0,1-cell-content'\n'2,0-cell-content','2,1-cell-content'");
+        });
+      });
+
+      describe("pressing Ctrl + C", function () {
+        beforeEach(function () {
+          event.ctrlKey = true;
+          event.keyCode = 67;
+        });
+
+        it("copies the cell content to the clipboard", function () {
+          handleQueryOutputKeyboardEvent(event, slickEvent);
+
+          expect(clipboard.copyTextToClipboard).toHaveBeenCalledWith("'0,0-cell-content','0,1-cell-content'\n'2,0-cell-content','2,1-cell-content'");
+        });
+      });
+
+      describe("pressing Command + A", function () {
+        beforeEach(function () {
+          event.metaKey = true;
+          event.keyCode = 65;
+        });
+
+        it("selects the entire grid to ranges", function () {
+          handleQueryOutputKeyboardEvent(event, slickEvent);
+
+          expect(RangeSelectionHelper.isEntireGridSelected(grid)).toBeTruthy();
+          expect(grid.getSelectionModel().getSelectedRanges().length).toBe(1);
+        });
+      });
+
+      describe("pressing Ctrl + A", function () {
+        beforeEach(function () {
+          event.ctrlKey = true;
+          event.keyCode = 65;
+        });
+
+        it("selects the entire grid to ranges", function () {
+          handleQueryOutputKeyboardEvent(event, slickEvent);
+
+          expect(RangeSelectionHelper.isEntireGridSelected(grid)).toBeTruthy();
+          expect(grid.getSelectionModel().getSelectedRanges().length).toBe(1);
+        });
+      });
+    });
+
+    describe("when no ranges are selected", function () {
+      describe("pressing Command + A", function () {
+        beforeEach(function () {
+          event.metaKey = true;
+          event.keyCode = 65;
+        });
+
+        it("selects the entire grid to ranges", function () {
+          handleQueryOutputKeyboardEvent(event, slickEvent);
+
+          expect(RangeSelectionHelper.isEntireGridSelected(grid)).toBeTruthy();
+          expect(grid.getSelectionModel().getSelectedRanges().length).toBe(1);
+        });
+      });
+
+      describe("pressing Ctrl + A", function () {
+        beforeEach(function () {
+          event.ctrlKey = true;
+          event.keyCode = 65;
+        });
+
+        it("selects the entire grid to ranges", function () {
+          handleQueryOutputKeyboardEvent(event, slickEvent);
+
+          expect(RangeSelectionHelper.isEntireGridSelected(grid)).toBeTruthy();
+          expect(grid.getSelectionModel().getSelectedRanges().length).toBe(1);
+        });
+      });
+    });
+  });
+});
\ No newline at end of file
diff --git a/web/regression/javascript/test-main.js b/web/regression/javascript/test-main.js
index fe28a5f8..b2db316d 100644
--- a/web/regression/javascript/test-main.js
+++ b/web/regression/javascript/test-main.js
@@ -36,6 +36,9 @@ require.config({
     'slickgrid': sourcesDir + 'vendor/slickgrid/slick.core',
     'slickgrid/slick.grid': sourcesDir + 'vendor/slickgrid/slick.grid',
     'slickgrid/slick.rowselectionmodel': sourcesDir + 'vendor/slickgrid/plugins/slick.rowselectionmodel',
+    'slickgrid/slick.cellselectionmodel': sourcesDir + 'vendor/slickgrid/plugins/slick.cellselectionmodel',
+    'slickgrid/slick.cellrangedecorator': sourcesDir + 'vendor/slickgrid/plugins/slick.cellrangedecorator',
+    'slickgrid/slick.cellrangeselector': sourcesDir + 'vendor/slickgrid/plugins/slick.cellrangeselector',
     'translations': '/base/regression/javascript/fake_translations',
     'sources': sourcesDir + 'js'
   },
diff --git a/web/regression/python_test_utils/test_utils.py b/web/regression/python_test_utils/test_utils.py
index 2b7c6954..a661ecfe 100644
--- a/web/regression/python_test_utils/test_utils.py
+++ b/web/regression/python_test_utils/test_utils.py
@@ -159,12 +159,14 @@ def create_table(server, db_name, table_name):
         connection.set_isolation_level(0)
         pg_cursor = connection.cursor()
         pg_cursor.execute(
-            '''CREATE TABLE "%s" (some_column VARCHAR, value NUMERIC)''' %
+            '''CREATE TABLE "%s" (some_column VARCHAR, value NUMERIC, details VARCHAR)''' %
             table_name)
         pg_cursor.execute(
-            '''INSERT INTO "%s" VALUES ('Some-Name', 6)''' % table_name)
+            '''INSERT INTO "%s" VALUES ('Some-Name', 6, 'some info')''' % table_name)
         pg_cursor.execute(
-            '''INSERT INTO "%s" VALUES ('Some-Other-Name', 22)''' % table_name)
+            '''INSERT INTO "%s" VALUES ('Some-Other-Name', 22, 'some other info')''' % table_name)
+        pg_cursor.execute(
+            '''INSERT INTO "%s" VALUES ('Yet-Another-Name', 14, 'cool info')''' % table_name)
 
         connection.set_isolation_level(old_isolation_level)
         connection.commit()
-- 
2.12.0

